----------------------------------------------------------------------------------
-- Create Date:    16:26:58 04/23/2012 
----------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity bridge_adc_uart is
    port (
        clk       : in  std_logic;
        reset     : in  std_logic;
        enable    : in  std_logic;
        init      : in  std_logic;
        mid       : in  std_logic;
        tx_empty  : in  std_logic;
        adc_done  : in  std_logic;
        tick      : in  std_logic;
        flag      : in  std_logic; 
        clr_flag  : out std_logic; 
        wr_uart  : out std_logic
    );
end bridge_adc_uart;

architecture Behavioral of bridge_adc_uart is
    signal wr_cur, wr_next : std_logic;
begin

-- register
process(clk, reset)
begin
    if rising_edge(clk) then
        if reset = '1' then
            wr_cur <= '0';
        else
            wr_cur <= wr_next;
        end if;
    end if;
end process;

-- next state logic
process(wr_cur, tick, init, mid, tx_empty, flag)
begin
    wr_next <= wr_cur;
    clr_flag <= '0'; 
    
    if tick = '1' then
        if (init = '1' and flag = '1') then
            wr_next <= tx_empty;
            clr_flag <= '1';
        elsif mid = '1' then
            wr_next <= '0';
        end if;
    end if;
end process;

-- output logic
wr_uart <= wr_cur and adc_done and enable;

end Behavioral;
