----------------------------------------------------------------------------------
-- Create Date:    17:58:48 10/01/2012 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use work.config.all;

entity fbg_config is
    Port ( clk        : in   STD_LOGIC;
           reset      : in   STD_LOGIC;
           sw         : in   STD_LOGIC;
           btn        : in   STD_LOGIC;
           count_fbg  : out  integer range 0 to MAX_FBGS
         ); 
end fbg_config;

architecture Behavioral of fbg_config is
type state_type is (selection, ready); 
signal state_reg, state_next: state_type; 
signal s_reg, s_next: integer range 0 to MAX_FBGS;


begin
             

-- FSMD state & data register
process(clk, reset)
begin
    if rising_edge(clk) then
        if reset = '1' then
            state_reg <= ready; 
            s_reg     <= 0; 
        else
            state_reg <= state_next;
            s_reg     <= s_next; 
        end if;
    end if;
end process; 

-- Next state logic & data path function units / routing
process(state_reg, s_reg, btn, sw)
begin
    state_next <= state_reg; 
    s_next <= s_reg; 

    case state_reg is 
        when ready =>
            if sw= '1' then
--                s_next <= 0; 
                state_next <= selection; 
            end if; 
            
        when selection =>
            if sw= '1' then 
                if (btn = '1') then
                    if (s_reg = MAX_FBGS) then
                        s_next <= 0; 
                    else
                        s_next <= s_reg + 1;
                    end if; 
                end if; 
            else
                state_next <= ready; 
            end if; 
    end case; 
    
end process; 

-- Output logic
count_fbg <= s_reg; 

end Behavioral;

