
-- Create Date:   11:30:58 06/06/2012

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY test_con_binary_bcd IS
END test_con_binary_bcd;
 
ARCHITECTURE behavior OF test_con_binary_bcd IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT con_binary_bcd
    PORT(
         clk : IN  std_logic;
         peak : IN  std_logic_vector(7 downto 0);
         num_bcd : OUT  std_logic_vector(11 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal peak : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal num_bcd : std_logic_vector(11 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: con_binary_bcd PORT MAP (
          clk => clk,
          peak => peak,
          num_bcd => num_bcd
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	

      wait for clk_period*10;

      -- insert stimulus here 
      peak <= "11111111"; 

      wait;
   end process;

END;
