--------------------------------------------------------------------------------
-- Create Date:   19:09:02 03/02/2012
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
 
entity test_ramp_gen is
end test_ramp_gen;
 
architecture behavior OF test_ramp_gen IS
    --Inputs
    signal clk      : std_logic := '0';
    signal reset    : std_logic := '0';
    signal tick     : std_logic := '0';
    signal enable   : std_logic := '1';

    --Outputs
    signal val       : std_logic_vector(7 downto 0);

    -- Clock period definitions
    constant clk_period : time := 10 ns;
begin
    uut: entity work.ramp_gen(behavioral) port map (
        clk     => clk,
        reset   => reset,
        tick    => tick,
        enable  => enable, 
        val     => val
    );

    -- Clock process definitions
    clk_process : process
    begin
        clk <= '0';
        wait for clk_period/2;
        clk <= '1';
        wait for clk_period/2;
    end process;
    
    tick_process : process
    begin
        tick <= '1';
        wait for clk_period;
        tick <= '0';
        wait for 1us;
    end process;
    
    -- Stimulus process
    stim_proc: process
    begin
        reset <= '1';
        wait for 200ns;
        reset <= '0';
        wait for 200ns;
        wait;
    end process;
END;
